#include "extension.h"

#include "standard.h"

#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/stat.h>

static struct scm_thing * create_character(unsigned char character) {
  struct scm_thing * rv = malloc(sizeof(struct scm_thing));
  rv->type = CHARACTER;
  rv->mutable = true;
  rv->character = character;
  return rv;
}

struct scm_thing * scm_snarf_file(struct scm_thing * args) {
  if (c_length(args) != 1) {
    error();
  }
  struct scm_thing * filename = args->car;
  if (!c_string_p(filename)) {
    error();
  }
  char * buf = malloc((filename->stringsize + 1) * sizeof(char));
  memcpy(buf, filename->string, filename->stringsize);
  buf[filename->stringsize] = '\0';
  int fd = open(buf, O_RDONLY);
  if (fd < 0) {
    perror("failed opening file");
    error();
  }
  struct stat file_stat;
  if (stat(buf, &file_stat) < 0) {
    perror("failed stating file");
    error();
  }
  unsigned char * characters = malloc(file_stat.st_size);
  if (read(fd, characters, file_stat.st_size) < 0) {
    perror("failed reading file");
    error();
  }
  struct scm_thing * vector = c_make_vector(file_stat.st_size);
  for (uint32_t i = 0; i < vector->vectorsize; i++) {
    vector->vector[i] = create_character(characters[i]);
  }
  return vector;
}
