#include "string.h"
#include "main.h"

char* escapestring(const char* string, const size_t length) {
    size_t escapedlength = 0;
    size_t i;
    for (i = 0; i < length; i++) {
        if (string[i] == '"' || string[i] == '\\')
            escapedlength++;
    }
    escapedlength += i;
    char* escapedstring = malloc(escapedlength + 1);
    size_t j = 0;
    for (i = 0; i < length; i++) {
        if (string[i] == '"' || string[i] == '\\') {
            escapedstring[j] = '\\';
            j++;
        }
        escapedstring[j] = string[i];
        j++;
    }
    escapedstring[escapedlength] = '\0';
    return escapedstring;
}

struct scm_thing processstring(char** characters) {
    struct scm_thing string;
    string.type = STRING;
    int stringlength = 1;
    size_t stringsize = 0;
    assert((*characters)[0] == '"');
    for (; (*characters)[stringlength] != '"'; stringlength++) {
        if ((*characters)[stringlength] == '\\') { // if there's a backslash we don't count it
            if ((*characters)[stringlength + 1] != '\\' && (*characters)[stringlength + 1] != '"') {
                printf("unknown escaped character %c, the backslash will be ignored\n", (*characters)[stringlength + 1]);
            }
            stringlength++;
        }
        stringsize++;
    }
    string.string = malloc(stringsize);
    string.stringsize = stringsize;
    stringsize = 0;
    for (stringlength = 1; (*characters)[stringlength] != '"'; stringlength++) {
        if ((*characters)[stringlength] == '\\') { // skip the backslash
            stringlength++;
        }
        string.string[stringsize] = (*characters)[stringlength];
        stringsize++;
    }
    //printf("string: \"%s\"\n", escapestring(string.string, stringsize));
    (*characters) += stringlength + 1;
    return string;
}
