(load "macros.scm")
(load "library.scm")

(define (is-initial? character)
  (or (and (char>=? character #\a)
	   (char<=? character #\z))
      (and (char>=? character #\A)
	   (char<=? character #\Z))
      (memq character
	    '(#\!
	      #\$
	      #\%
	      #\&
	      #\*
	      #\/
	      #\:
	      #\<
	      #\=
	      #\>
	      #\?
	      #\^
	      #\_
	      #\~))))

(define (read-prefix))

;; will probably leave turning characters into numbers until the compiler is working
;; because then it can be done with assembly instructions

(define (read-num port first-character second-character)
  )

(define (read-token port)
  (let ((first-character (read-char port)))
    (cond ((assq-ref '((#\( . 'open-paren)
		       (#\) . 'close-paren)
		       (#\' . 'apostrophe)
		       (#\` . 'backtick))
		     first-character))
	  ((is-initial? first-character)
	   (do ((characters (list first-character) (cons (read-char port) characters)))
	       ((is-delimiter? (peek-char port))
		(cons 'identifier characters))
	     ;; need an error-checking here
	     ))
	  ((and (memq first-character '(#\+ #\-))
		(is-delimiter? (peek-char port)))
	   (list 'identifier first-character))
	  ((and (eq? first-character #\.)
		(eq? (peek-char port) #\.))
	   (read-char port)
	   (read-char port)
	   ;; need an error-check here
	   (list 'identifier #\. #\. #\.))
	  ((eq? first-character #\.)
	   ;; need error-check, next char should be a delimiter
	   'dot)
	  ((eq? first-character #\")
	   (do ((characters '() (cons (read-char port) characters)))
	       ((eq? (peek-char port) #\")
		(read-char port)
		(cons 'string characters))
	     (if (eq? (peek-char port) #\\)
		 (read-char port))))
	  ((eq? first-character #\#)
	   (let ((second-character (read-char port)))
	     (cond ((eq? second-character #\t)
		    (cons 'boolean #t))
		   ((eq? second-character #\f)
		    (cons 'boolean #f))
		   ((eq? second-character #\()
		    'open-vector)
		   ((eq? second-character #\\)
		    (let ((third-character (read-char port)))
		      (cond ((is-delimiter? (peek-char port))
			     (cons 'character third-character))
			    ;; need to parse space and newline
			    )))
		   ((read-num port first-character second-character)))))
	  ))))

(define (read . args)
  (let ((port (if (null? args)
		  (current-input-port)
		  (car args))))
    ))
