
(define-syntax let
  (syntax-rules ()
    ((let ((name val) ...) body1 body2 ...)
     ((lambda (name ...) body1 body2 ...)
      val ...))
    ((let tag ((name val) ...) body1 body2 ...)
     ((letrec ((tag (lambda (name ...)
		      body1 body2 ...)))
	tag)
      val ...))))

;; closure
(let ((x 5))
  ((lambda (y)
     (* x
	((lambda (x) (+ x 1))
	 y)))
   2))

((lambda (list)
   ((lambda (internal-loop)
       (set! internal-loop
	     (lambda (list new-list)
	       (if (null? list)
		   new-list
		   list)))
       (internal-loop list '()))
    #f))
 '(1 2 3))

;; ellipses
(define-syntax useless
  (syntax-rules ()
    ((useless args ...)
     (args ...))))

(useless + 1 2)

(load "macros.scm")

;; testing closure
;; i am going to modify quote to avoid this issue, but
;; it is possible that it comes up when using other macros
(let ((var 3))
  (letrec ((var2 'var))
    var2))

;; i saw something that was wrong
((lambda (green)
   ((lambda (list)
      list)
    '(1)))
 4)
